<?php

// Register the currency switcher shortcode
function currency_switcher_shortcode() {
    $currencies = [
        'USD' => 'fa-usd',
        'TRY' => 'fa-lira-sign'
    ];

    // Get the selected currency from the cookie (default to USD)
    $selected_currency = isset($_COOKIE['selected_currency']) ? $_COOKIE['selected_currency'] : 'USD';

    // Output the dropdown with flags
    ob_start();
    ?>
   
    <select id="currency-selector" class="form-select">
        <?php foreach ($currencies as $currency_code => $icon_class): ?>
            <option value="<?php echo esc_attr($currency_code); ?>" <?php selected($currency_code, $selected_currency); ?>>
                <?php echo esc_html($currency_code); ?>
            </option>
        <?php endforeach; ?>
    </select>

    <?php
    return ob_get_clean();
}
add_shortcode('currency_switcher', 'currency_switcher_shortcode');

// AJAX function to update the currency in cookie
function update_currency_cookie() {
    if (isset($_POST['currency'])) {
        $currency = sanitize_text_field($_POST['currency']);
        
        // Set a cookie for 30 days
        setcookie('selected_currency', $currency, time() + (30 * DAY_IN_SECONDS), COOKIEPATH, COOKIE_DOMAIN);
        
        wp_send_json_success("Currency updated to {$currency}");
    }
    wp_send_json_error("Currency not set.");
}
add_action('wp_ajax_update_currency', 'update_currency_cookie');
add_action('wp_ajax_nopriv_update_currency', 'update_currency_cookie');

// Access the currency cookie in PHP (example function)
function get_selected_currency() {
    return isset($_COOKIE['selected_currency']) ? sanitize_text_field($_COOKIE['selected_currency']) : 'USD';
}

?>

