<?php


// Get the land_id from the URL parameter using $_GET without casting it to an integer
$land_id = isset($_GET['land_id']) ? sanitize_text_field($_GET['land_id']) : '';
$land_data = emlak_get_land_by_id($land_id);
function load_single_land_template($land_data){
    $selected_currency = isset($_COOKIE['selected_currency']) ? $_COOKIE['selected_currency'] : 'USD'; 
    $meter_price = $land_data['meter_price'];
    $land_space = $land_data['land_space'];
    $total_price = $meter_price * $land_space;
    $total_price = number_format($total_price, 2, '.', ',');

    ?>
    <div class="container-fluid primary-section">
        <div class="container px-0">
            <div class="row">
                <div class="col-lg-12 col-md-12 col-sm-12">
                    <h1 class="mx-0 my-0"><?php echo $land_data['title']; ?></h1>
                    <p class="pt-2"><?php echo $land_data['description']; ?></p>
                </div>
            </div>
        </div>
    </div>

    <div class="container-fluid single-land px-0">
        <div class="container pt-5 pb-5">
            <div class="row">
                <div class="col-lg-8 col-md-12 col-sm-12">
                    <!-- Carousel for images with Fancybox -->
                    <div id="landCarousel" class="carousel slide" data-bs-ride="carousel">
                        <div class="carousel-inner">
                            <?php 
                            // Assuming $land_data['pics'] contains the array of image URLs
                            $pics = $land_data['pics'];
                            foreach ($pics as $index => $pic) {
                                // Check if it's the first item to set it as active
                                $activeClass = ($index === 0) ? 'active' : '';
                                echo '<div class="carousel-item ' . $activeClass . '">';
                                echo '<a href="' . $pic . '" data-fancybox="landImages">';
                                echo '<img src="' . $pic . '" class="d-block w-100" alt="Land Image ' . ($index + 1) . '">';
                                echo '</a>';
                                echo '</div>';
                            }
                            ?>
                        </div>
                        <button class="carousel-control-prev" type="button" data-bs-target="#landCarousel" data-bs-slide="prev">
                            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                            <span class="visually-hidden">Previous</span>
                        </button>
                        <button class="carousel-control-next" type="button" data-bs-target="#landCarousel" data-bs-slide="next">
                            <span class="carousel-control-next-icon" aria-hidden="true"></span>
                            <span class="visually-hidden">Next</span>
                        </button>
                    </div>

                    <div class="details-box">
                        <div class="container p-0">
                            <div class="row g-3">
                                <div class="col-lg-4 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p><strong>Location</strong></p>
                                        </div>
                                        <div class="pb-2">
                                            <i class="fa-solid fa-location-crosshairs"></i>
                                        </div>
                                        <div>
                                            <p><?php echo $land_data['location_text']['title']; ?></p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-4 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p><strong>Price</strong></p>
                                        </div>
                                        <div class="pb-2">
                                            <i class="fa-solid fa-money-bill-1-wave"></i>
                                        </div>
                                        <div>
                                            <p>
                                                <span><?php echo $land_data['meter_price']; ?>
                                                    <small class="text-uppercase currency"><?php echo $selected_currency ?></small>
                                                </span> /
                                                <span class="text-lowercase">
                                                    m<sup>2</sup>
                                                </span>
                                            </p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-4 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p><strong>Payment Method</strong></p>
                                        </div>
                                        <div class="pb-2">
                                            <i class="fa-solid fa-credit-card"></i>
                                        </div>
                                        <div>
                                            <?php if (empty($project_data['payments'])) : ?>
                                                <p>Cash</p>
                                            <?php else : ?>
                                                <div class="d-flex w-100 instalments-box">
                                                    <div class="w-50">
                                                        <span> <strong><?php echo $project_data['downpayment']; ?>%</strong> <br>
                                                        <small>Down Payment</small></span>
                                                    </div>
                                                    <div class="mx-2">|</div>
                                                    <div class="w-50">
                                                        <span><strong><?php echo $project_data['payments']; ?></strong><br>
                                                        <small>Installments</small></span>
                                                    </div>
                                                </div>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="details-box">
                        <div>
                            <h4>Real Estate Information</h4>
                        </div>
                        <div>
                            <?php echo $land_data['project_information']; ?>
                        </div>
                    </div>

                    <div class="details-box">
                        <div class="container p-0">
                            <div class="row g-3">
                                <div>
                                    <h4>Location</h4>
                                </div>
                                
                                <?php if (isset($land_data['location_info']) && is_array($land_data['location_info'])): ?>
                                <div class="container">
                                    <div class="row g-3 mt-1">
                                        <?php foreach ($land_data['location_info'] as $location): ?>
                                            <div class="col-lg-4 col-md-12 col-sm-12">
                                                <div class="inner-details text-center">
                                                    <div class="pt-3 pb-3">
                                                        <!-- Embed the SVG directly from the URL -->
                                                        <div class="location-icon">
                                                            <img src="<?php echo $location['img']; ?>" alt="<?php echo $location['title']; ?>" class="location-icon">
                                                        </div>
                                                    </div>
                                                    <div>
                                                        <p class="m-0"><strong><?php echo $location['title']; ?></strong></p>
                                                        <p><?php echo $location['value'] . ' ' . $location['unit']; ?></p>
                                                    </div>
                                                </div>
                                            </div>
                                        <?php endforeach; ?>
                                    </div>

                                </div>
                                <?php else: ?>
                                    <p>No location information available.</p>
                                <?php endif; ?>


                            </div>
                        </div>
                    </div>

                    <div class="details-box long-list">
                        <div>
                            <h4>Why this</h4>
                        </div>
                        <div>
                            <?php echo $land_data['why_this']; ?>
                        </div>

                    </div>

                    <div class="details-box">
                        <div class="map">
                            <?php
                            // Accessing the latitude and longitude from the location_map array
                            $latitude = $land_data['location_map'][0];
                            $longitude = $land_data['location_map'][1];
                            ?>
                            <iframe
                                src="https://maps.google.com/maps?q=<?php echo $latitude; ?>,<?php echo $longitude; ?>&t=&z=13&ie=UTF8&iwloc=&output=embed"
                                width="100%" height="400"></iframe>
                        </div>
                    </div>


                    <div class="details-box stat-details">
                        <div class="container p-0">
                            <div class="row g-3">
                                <div>
                                    <h4>Area Details</h4>
                                </div>
                                <div class="col-lg-3 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">Population</p>
                                            <p class="number m-0"><?php echo number_format($land_data['location_text']['population'], 0, '.', ','); ?></p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-3 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">Male Sex Ratio</p>
                                            <p class="number m-0"><?php echo $land_data['location_text']['male']; ?>%</p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-3 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">Female Sex Ratio</p>
                                            <p class="number m-0"><?php echo $land_data['location_text']['female']; ?>%</p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-3 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">Class</p>
                                            <p class="number m-0"><?php echo $land_data['location_text']['rate']; ?></p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="details-box stat-details">
                        <div class="container p-0">
                            <div class="row g-3">
                                <div>
                                    <h4>Price Change</h4>
                                </div>
                                <div class="col-lg-4 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">1 Year</p>
                                            <p class="number m-0">
                                                <?php echo $land_data['location_text']['p1']; ?>%
                                            </p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-4 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">3 Years</p>
                                            <p class="number m-0">
                                                <?php echo $land_data['location_text']['p2']; ?>%
                                            </p>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-4 col-md-12 col-sm-12">
                                    <div class="inner-details text-center">
                                        <div>
                                            <p class="m-0">5 Years</p>
                                            <p class="number m-0">
                                                <?php echo $land_data['location_text']['p3']; ?>%
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <!-- Sticky Sidebar with Details -->
                <div class="col-lg-4 col-md-12 col-sm-12 sticky-column">
                    <div class="details-box">
                        <table class="table custom-table m-0">
                            <tbody>
                                <tr>
                                    <td><strong>Total Price</strong></td>
                                    <td class="text-end"><span class="price"><?php echo $total_price; ?> <?php echo $selected_currency; ?></span></td>
                                </tr>
                                <tr>
                                    <td><strong>Location</strong></td>
                                    <td class="text-end"><?php echo $land_data['location_text']['title']; ?></td>
                                </tr>
                                <tr>
                                    <td><strong>Construction Percentage</strong></td>
                                    <td class="text-end"><?php echo $land_data['construction_percentage']; ?><span>%</span></td>
                                </tr>
                                <tr>
                                    <td><strong>Land Type</strong></td>
                                    <td class="text-end"><?php echo $land_data['land_type']; ?></td>
                                </tr>
                                <tr>
                                    <td><strong>Construction License</strong></td>
                                    <td class="text-end"><?php echo $land_data['construction_license']; ?></td>
                                </tr>
                                <tr>
                                    <td><strong>Land License</strong></td>
                                    <td class="text-end"><?php echo $land_data['land_license'][0]; ?></td>
                                </tr>
                                <tr>
                                    <td><strong>Area</strong></td>
                                    <td class="text-end"><?php echo $land_data['land_space']; ?> m<sup>2</sup></td>
                                </tr>
                                <tr>
                                    <td><strong>Number of Floors</strong></td>
                                    <td class="text-end"><?php echo $land_data['number_of_floors']; ?></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <?php
}

get_header();  // Include the header

?>

<div class="single-land">
    <?php if ( $land_id ): ?>
        <?php load_single_land_template($land_data); ?>
    <?php else: ?>
        <p>No land ID was provided in the URL.</p>
    <?php endif; ?>
</div>

<?php

get_footer();  // Include the footer